package xn.huaxue.update;

import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.util.Log;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;

import com.blankj.utilcode.util.AppUtils;
import com.blankj.utilcode.util.LogUtils;
import com.blankj.utilcode.util.NetworkUtils;
import com.blankj.utilcode.util.SPUtils;
import com.blankj.utilcode.util.ToastUtils;

import xn.huaxue.update.constant.AppConstant;
import xn.huaxue.update.databinding.ActivitySettingBinding;

public class SettingActivity extends AppCompatActivity {

    private ActivitySettingBinding binding;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = ActivitySettingBinding.inflate(getLayoutInflater());
        setContentView(binding.getRoot());
    }

    @Override
    protected void onPostCreate(@Nullable Bundle savedInstanceState) {
        super.onPostCreate(savedInstanceState);
        binding.varBT.setText("版本:" + AppUtils.getAppVersionName());
        binding.snBT.setText("SN:" + Tool.INSTANCE.getSerialNumber());
        binding.ipBT.setText(NetworkUtils.getIPAddress(true));
        binding.rebootBT.setOnClickListener(v -> Tool.INSTANCE.cmd("reboot"));
        binding.fileBrowserBT.setOnClickListener(v -> Tool.INSTANCE.openFileBrowser());
        binding.settingBT.setOnClickListener(v -> Tool.INSTANCE.openSetting());
        binding.barSwitch.setOnCheckedChangeListener((buttonView, isChecked) -> Tool.INSTANCE.showBar(isChecked));

        binding.httpUriET.setText(SPUtils.getInstance().getString(AppConstant.BASE_URL, Tool.INSTANCE.getBaseUrl().toString()));
        // 管理员密码
        binding.oldPasswordET.setText(SPUtils.getInstance().getString(AppConstant.ADMIN_PASSWORD, "admin@098&"));
        // 测试地址输入
        binding.httpUriTestBT.setOnClickListener(v -> binding.httpUriET.setText("http://192.168.1.8/api/"));
        // 线上地址输入
        binding.httpUriXnBT.setOnClickListener(v -> binding.httpUriET.setText("http://10.148.100.82/api/"));
        // 保存
        binding.save.setOnClickListener(v -> save());

    }


    @Override
    public void onBackPressed() {
    }

    private void save() {
        try {
            Editable text = this.binding.httpUriET.getText();
            if (text != null && !TextUtils.isEmpty(text)) {
                Editable text2 = this.binding.oldPasswordET.getText();
                if (text2 != null && !TextUtils.isEmpty(text2)) {
                    SPUtils.getInstance().put(AppConstant.ADMIN_PASSWORD, text2.toString(), true);
                    SPUtils.getInstance().put(AppConstant.BASE_URL, text.toString(), true);
                    finish();
                    return;
                }
                this.binding.oldPasswordET.setError("请输入管理员密码");
                return;
            }
            this.binding.httpUriET.setError("请输入Http服务地址");
        } catch (Exception e) {
            ToastUtils.showLong("参数异常无法保存,请核对参数!");
            LogUtils.e(Log.getStackTraceString(e));
        }

    }

}