package xn.huaxue.update.http;


import com.blankj.utilcode.util.AppUtils;
import com.blankj.utilcode.util.NetworkUtils;
import com.blankj.utilcode.util.ShellUtils;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStreamReader;

import okhttp3.Response;
import xn.huaxue.update.Tool;

public enum HttpTool {
    INSTANCE;

    public Response terminalAuth() throws IOException, JSONException {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("deviceCode", Tool.INSTANCE.getSerialNumber());
        jsonObject.put("code", "aio_chemical");
        return OkHttpUtils.INSTANCE.postSync(Tool.INSTANCE.getBaseUrl() + "terminal/authorize", jsonObject.toString());
    }

    public Response update() throws IOException, JSONException {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("deviceCode", Tool.INSTANCE.getSerialNumber());
        return OkHttpUtils.INSTANCE.postSync(Tool.INSTANCE.getBaseUrl() + "terminal/upgrade/device/task", jsonObject.toString());
    }

    public void updateCallBack(String taskId, String deviceCode, boolean isDownload, boolean isInstall) throws IOException, JSONException {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("taskId", taskId);
        jsonObject.put("deviceCode", deviceCode);
        if (isDownload) {
            jsonObject.put("status", "downloaded");
        }
        if (isInstall) {
            jsonObject.put("status", "success");
        }
        OkHttpUtils.INSTANCE.postSync(Tool.INSTANCE.getBaseUrl() + "terminal/upgrade/device/callback", jsonObject.toString());
    }

    public Response heartbeat() throws JSONException, IOException {
        JSONObject jsonObject = new JSONObject();
        ShellUtils.CommandResult commandResult = ShellUtils.execCmd("dumpsys activity activities", true);
        BufferedReader reader = new BufferedReader(new InputStreamReader(new ByteArrayInputStream(commandResult.successMsg.getBytes())));
        String line;
        boolean isShow = false;
        while ((line = reader.readLine()) != null) {
            if (line.contains("mResumedActivity") || line.contains("mCurrentFocus")) {
                String[] itemArray = line.split(" ", -1);
                for (String item : itemArray) {
                    if (item.contains("/")) {
                        String packageName = item.substring(0, item.indexOf("/"));
                        isShow = AppUtils.getAppPackageName().equals(packageName);
                        break;
                    }
                }
                break;
            }
        }
        // Ip
        jsonObject.put("deviceNo", Tool.INSTANCE.getSerialNumber());
        jsonObject.put("versionName", AppUtils.getAppVersionName());
        jsonObject.put("packageName", AppUtils.getAppPackageName());
        jsonObject.put("isShow", isShow);
        jsonObject.put("adbEnabled", true);
        jsonObject.put("ip", NetworkUtils.getIPAddress(true));
        return OkHttpUtils.INSTANCE.postSync(Tool.INSTANCE.getBaseUrl() + "terminal/machine/upgrade/heartbeat", jsonObject.toString());
    }

}
